#![allow(unused_parens)]
#![allow(unused_imports)]

use std::convert::TryFrom;
use preserves::value::Domain;
use preserves::value::NestedValue;
use crate::support as _support;

_support::lazy_static! {
    pub static ref LIT_15_FALSE: preserves::value::IOValue = /* #f */ preserves::value::packed::from_bytes(&vec![128]).unwrap();
    pub static ref LIT_28_1: preserves::value::IOValue = /* 1 */ preserves::value::packed::from_bytes(&vec![145]).unwrap();
    pub static ref LIT_0_BOOLEAN: preserves::value::IOValue = /* Boolean */ preserves::value::packed::from_bytes(&vec![179, 7, 66, 111, 111, 108, 101, 97, 110]).unwrap();
    pub static ref LIT_5_BYTE_STRING: preserves::value::IOValue = /* ByteString */ preserves::value::packed::from_bytes(&vec![179, 10, 66, 121, 116, 101, 83, 116, 114, 105, 110, 103]).unwrap();
    pub static ref LIT_2_DOUBLE: preserves::value::IOValue = /* Double */ preserves::value::packed::from_bytes(&vec![179, 6, 68, 111, 117, 98, 108, 101]).unwrap();
    pub static ref LIT_1_FLOAT: preserves::value::IOValue = /* Float */ preserves::value::packed::from_bytes(&vec![179, 5, 70, 108, 111, 97, 116]).unwrap();
    pub static ref LIT_3_SIGNED_INTEGER: preserves::value::IOValue = /* SignedInteger */ preserves::value::packed::from_bytes(&vec![179, 13, 83, 105, 103, 110, 101, 100, 73, 110, 116, 101, 103, 101, 114]).unwrap();
    pub static ref LIT_4_STRING: preserves::value::IOValue = /* String */ preserves::value::packed::from_bytes(&vec![179, 6, 83, 116, 114, 105, 110, 103]).unwrap();
    pub static ref LIT_6_SYMBOL: preserves::value::IOValue = /* Symbol */ preserves::value::packed::from_bytes(&vec![179, 6, 83, 121, 109, 98, 111, 108]).unwrap();
    pub static ref LIT_14_AND: preserves::value::IOValue = /* and */ preserves::value::packed::from_bytes(&vec![179, 3, 97, 110, 100]).unwrap();
    pub static ref LIT_21_ANY: preserves::value::IOValue = /* any */ preserves::value::packed::from_bytes(&vec![179, 3, 97, 110, 121]).unwrap();
    pub static ref LIT_22_ATOM: preserves::value::IOValue = /* atom */ preserves::value::packed::from_bytes(&vec![179, 4, 97, 116, 111, 109]).unwrap();
    pub static ref LIT_8_BUNDLE: preserves::value::IOValue = /* bundle */ preserves::value::packed::from_bytes(&vec![179, 6, 98, 117, 110, 100, 108, 101]).unwrap();
    pub static ref LIT_18_DEFINITIONS: preserves::value::IOValue = /* definitions */ preserves::value::packed::from_bytes(&vec![179, 11, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 115]).unwrap();
    pub static ref LIT_12_DICT: preserves::value::IOValue = /* dict */ preserves::value::packed::from_bytes(&vec![179, 4, 100, 105, 99, 116]).unwrap();
    pub static ref LIT_27_DICTOF: preserves::value::IOValue = /* dictof */ preserves::value::packed::from_bytes(&vec![179, 6, 100, 105, 99, 116, 111, 102]).unwrap();
    pub static ref LIT_23_EMBEDDED: preserves::value::IOValue = /* embedded */ preserves::value::packed::from_bytes(&vec![179, 8, 101, 109, 98, 101, 100, 100, 101, 100]).unwrap();
    pub static ref LIT_19_EMBEDDED_TYPE: preserves::value::IOValue = /* embeddedType */ preserves::value::packed::from_bytes(&vec![179, 12, 101, 109, 98, 101, 100, 100, 101, 100, 84, 121, 112, 101]).unwrap();
    pub static ref LIT_24_LIT: preserves::value::IOValue = /* lit */ preserves::value::packed::from_bytes(&vec![179, 3, 108, 105, 116]).unwrap();
    pub static ref LIT_7_NAMED: preserves::value::IOValue = /* named */ preserves::value::packed::from_bytes(&vec![179, 5, 110, 97, 109, 101, 100]).unwrap();
    pub static ref LIT_13_OR: preserves::value::IOValue = /* or */ preserves::value::packed::from_bytes(&vec![179, 2, 111, 114]).unwrap();
    pub static ref LIT_9_REC: preserves::value::IOValue = /* rec */ preserves::value::packed::from_bytes(&vec![179, 3, 114, 101, 99]).unwrap();
    pub static ref LIT_16_REF: preserves::value::IOValue = /* ref */ preserves::value::packed::from_bytes(&vec![179, 3, 114, 101, 102]).unwrap();
    pub static ref LIT_17_SCHEMA: preserves::value::IOValue = /* schema */ preserves::value::packed::from_bytes(&vec![179, 6, 115, 99, 104, 101, 109, 97]).unwrap();
    pub static ref LIT_25_SEQOF: preserves::value::IOValue = /* seqof */ preserves::value::packed::from_bytes(&vec![179, 5, 115, 101, 113, 111, 102]).unwrap();
    pub static ref LIT_26_SETOF: preserves::value::IOValue = /* setof */ preserves::value::packed::from_bytes(&vec![179, 5, 115, 101, 116, 111, 102]).unwrap();
    pub static ref LIT_10_TUPLE: preserves::value::IOValue = /* tuple */ preserves::value::packed::from_bytes(&vec![179, 5, 116, 117, 112, 108, 101]).unwrap();
    pub static ref LIT_11_TUPLE_PREFIX: preserves::value::IOValue = /* tuplePrefix */ preserves::value::packed::from_bytes(&vec![179, 11, 116, 117, 112, 108, 101, 80, 114, 101, 102, 105, 120]).unwrap();
    pub static ref LIT_20_VERSION: preserves::value::IOValue = /* version */ preserves::value::packed::from_bytes(&vec![179, 7, 118, 101, 114, 115, 105, 111, 110]).unwrap();
}

pub type _Ptr = preserves::value::IOValue;

pub type _Any = preserves::value::ArcValue<_Ptr>;

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum AtomKind {Boolean, Float, Double, SignedInteger, String, ByteString, Symbol}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct Binding {pub name: std::string::String, pub pattern: SimplePattern}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct Bundle {pub modules: Modules}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum CompoundPattern {
    Rec {label: std::boxed::Box<NamedPattern>, fields: std::boxed::Box<NamedPattern>},
    Tuple {patterns: std::vec::Vec<NamedPattern>},
    TuplePrefix {
        fixed: std::vec::Vec<NamedPattern>,
        variable: std::boxed::Box<NamedSimplePattern>
    },
    Dict {entries: std::boxed::Box<DictionaryEntries>}
}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum Definition {
    Or {
        pattern_0: std::boxed::Box<NamedAlternative>,
        pattern_1: std::boxed::Box<NamedAlternative>,
        pattern_n: std::vec::Vec<NamedAlternative>
    },
    And {
        pattern_0: std::boxed::Box<NamedPattern>,
        pattern_1: std::boxed::Box<NamedPattern>,
        pattern_n: std::vec::Vec<NamedPattern>
    },
    Pattern(std::boxed::Box<Pattern>)
}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct Definitions(pub preserves::value::Map<std::string::String, Definition>);

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct DictionaryEntries(pub preserves::value::Map<_Any, NamedSimplePattern>);

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum EmbeddedTypeName {Ref(std::boxed::Box<Ref>), False}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct ModulePath(pub std::vec::Vec<std::string::String>);

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct Modules(pub preserves::value::Map<ModulePath, Schema>);

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct NamedAlternative {pub variant_label: std::string::String, pub pattern: Pattern}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum NamedPattern {Named(std::boxed::Box<Binding>), Anonymous(std::boxed::Box<Pattern>)}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum NamedSimplePattern {Named(std::boxed::Box<Binding>), Anonymous(std::boxed::Box<SimplePattern>)}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum Pattern {
    SimplePattern(std::boxed::Box<SimplePattern>),
    CompoundPattern(std::boxed::Box<CompoundPattern>)
}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct Ref {pub module: ModulePath, pub name: std::string::String}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct Schema {
    pub definitions: Definitions,
    pub embedded_type: EmbeddedTypeName,
    pub version: Version
}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub enum SimplePattern {
    Any,
    Atom {atom_kind: std::boxed::Box<AtomKind>},
    Embedded {interface: std::boxed::Box<SimplePattern>},
    Lit {value: _Any},
    Seqof {pattern: std::boxed::Box<SimplePattern>},
    Setof {pattern: std::boxed::Box<SimplePattern>},
    Dictof {key: std::boxed::Box<SimplePattern>, value: std::boxed::Box<SimplePattern>},
    Ref(std::boxed::Box<Ref>)
}

#[derive(Debug, PartialOrd, Ord, PartialEq, Eq, Clone, Hash)]
pub struct Version;

fn _parse_atom_kind_boolean(value: &preserves::value::IOValue) -> std::result::Result<AtomKind, _support::ParseError> {
    if value != &*LIT_0_BOOLEAN { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(AtomKind::Boolean)
}

fn _parse_atom_kind_float(value: &preserves::value::IOValue) -> std::result::Result<AtomKind, _support::ParseError> {
    if value != &*LIT_1_FLOAT { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(AtomKind::Float)
}

fn _parse_atom_kind_double(value: &preserves::value::IOValue) -> std::result::Result<AtomKind, _support::ParseError> {
    if value != &*LIT_2_DOUBLE { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(AtomKind::Double)
}

fn _parse_atom_kind_signed_integer(value: &preserves::value::IOValue) -> std::result::Result<AtomKind, _support::ParseError> {
    if value != &*LIT_3_SIGNED_INTEGER { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(AtomKind::SignedInteger)
}

fn _parse_atom_kind_string(value: &preserves::value::IOValue) -> std::result::Result<AtomKind, _support::ParseError> {
    if value != &*LIT_4_STRING { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(AtomKind::String)
}

fn _parse_atom_kind_byte_string(value: &preserves::value::IOValue) -> std::result::Result<AtomKind, _support::ParseError> {
    if value != &*LIT_5_BYTE_STRING { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(AtomKind::ByteString)
}

fn _parse_atom_kind_symbol(value: &preserves::value::IOValue) -> std::result::Result<AtomKind, _support::ParseError> {
    if value != &*LIT_6_SYMBOL { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(AtomKind::Symbol)
}

impl std::convert::TryFrom<preserves::value::IOValue> for AtomKind {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_atom_kind_boolean(value) { return Ok(r); }
        if let Ok(r) = _parse_atom_kind_float(value) { return Ok(r); }
        if let Ok(r) = _parse_atom_kind_double(value) { return Ok(r); }
        if let Ok(r) = _parse_atom_kind_signed_integer(value) { return Ok(r); }
        if let Ok(r) = _parse_atom_kind_string(value) { return Ok(r); }
        if let Ok(r) = _parse_atom_kind_byte_string(value) { return Ok(r); }
        if let Ok(r) = _parse_atom_kind_symbol(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&AtomKind> for preserves::value::IOValue {
    fn from(value: &AtomKind) -> Self {
        match value {
            AtomKind::Boolean => (&*LIT_0_BOOLEAN).clone(),
            AtomKind::Float => (&*LIT_1_FLOAT).clone(),
            AtomKind::Double => (&*LIT_2_DOUBLE).clone(),
            AtomKind::SignedInteger => (&*LIT_3_SIGNED_INTEGER).clone(),
            AtomKind::String => (&*LIT_4_STRING).clone(),
            AtomKind::ByteString => (&*LIT_5_BYTE_STRING).clone(),
            AtomKind::Symbol => (&*LIT_6_SYMBOL).clone(),
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for Binding {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let _tmp0 = value.value().to_record(None)?;
        if _tmp0.label() != &*LIT_7_NAMED { return Err(_support::ParseError::ConformanceError); }
        let _tmp1 = ();
        if _tmp0.fields().len() < 2 { return Err(_support::ParseError::ConformanceError); }
        let _tmp2 = (&_tmp0.fields()[0]).value().to_symbol()?;
        let _tmp3 = SimplePattern::try_from((&_tmp0.fields()[1]).clone())?;
        Ok(Binding {name: _tmp2.clone(), pattern: _tmp3})
    }
}

impl std::convert::From<&Binding> for preserves::value::IOValue {
    fn from(value: &Binding) -> Self {
        let Binding {name: _tmp0, pattern: _tmp1} = value;
        {
            let mut _tmp2 = preserves::value::Record(vec![(&*LIT_7_NAMED).clone()]);
            _tmp2.fields_vec_mut().push(preserves::value::Value::symbol(_tmp0).wrap());
            _tmp2.fields_vec_mut().push(preserves::value::IOValue::from(_tmp1));
            _tmp2.finish().wrap()
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for Bundle {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let _tmp0 = value.value().to_record(None)?;
        if _tmp0.label() != &*LIT_8_BUNDLE { return Err(_support::ParseError::ConformanceError); }
        let _tmp1 = ();
        if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
        let _tmp2 = Modules::try_from((&_tmp0.fields()[0]).clone())?;
        Ok(Bundle {modules: _tmp2})
    }
}

impl std::convert::From<&Bundle> for preserves::value::IOValue {
    fn from(value: &Bundle) -> Self {
        let Bundle {modules: _tmp0} = value;
        {
            let mut _tmp1 = preserves::value::Record(vec![(&*LIT_8_BUNDLE).clone()]);
            _tmp1.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0));
            _tmp1.finish().wrap()
        }
    }
}

fn _parse_compound_pattern_rec(value: &preserves::value::IOValue) -> std::result::Result<CompoundPattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_9_REC { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 2 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = NamedPattern::try_from((&_tmp0.fields()[0]).clone())?;
    let _tmp3 = NamedPattern::try_from((&_tmp0.fields()[1]).clone())?;
    Ok(CompoundPattern::Rec {label: std::boxed::Box::new(_tmp2), fields: std::boxed::Box::new(_tmp3)})
}

fn _parse_compound_pattern_tuple(value: &preserves::value::IOValue) -> std::result::Result<CompoundPattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_10_TUPLE { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp3 = (&_tmp0.fields()[0]).value().to_sequence()?;
    let mut _tmp2 = std::vec::Vec::new();
    for _tmp4 in &_tmp3[0..] {let _tmp5 = NamedPattern::try_from(_tmp4.clone())?; _tmp2.push(_tmp5);}
    Ok(CompoundPattern::Tuple {patterns: _tmp2})
}

fn _parse_compound_pattern_tuple_prefix(value: &preserves::value::IOValue) -> std::result::Result<CompoundPattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_11_TUPLE_PREFIX { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 2 { return Err(_support::ParseError::ConformanceError); }
    let _tmp3 = (&_tmp0.fields()[0]).value().to_sequence()?;
    let mut _tmp2 = std::vec::Vec::new();
    for _tmp4 in &_tmp3[0..] {let _tmp5 = NamedPattern::try_from(_tmp4.clone())?; _tmp2.push(_tmp5);}
    let _tmp6 = NamedSimplePattern::try_from((&_tmp0.fields()[1]).clone())?;
    Ok(CompoundPattern::TuplePrefix {fixed: _tmp2, variable: std::boxed::Box::new(_tmp6)})
}

fn _parse_compound_pattern_dict(value: &preserves::value::IOValue) -> std::result::Result<CompoundPattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_12_DICT { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = DictionaryEntries::try_from((&_tmp0.fields()[0]).clone())?;
    Ok(CompoundPattern::Dict {entries: std::boxed::Box::new(_tmp2)})
}

impl std::convert::TryFrom<preserves::value::IOValue> for CompoundPattern {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_compound_pattern_rec(value) { return Ok(r); }
        if let Ok(r) = _parse_compound_pattern_tuple(value) { return Ok(r); }
        if let Ok(r) = _parse_compound_pattern_tuple_prefix(value) { return Ok(r); }
        if let Ok(r) = _parse_compound_pattern_dict(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&CompoundPattern> for preserves::value::IOValue {
    fn from(value: &CompoundPattern) -> Self {
        match value {
            CompoundPattern::Rec {label: _tmp0, fields: _tmp1} => {
                let mut _tmp2 = preserves::value::Record(vec![(&*LIT_9_REC).clone()]);
                _tmp2.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0.as_ref()));
                _tmp2.fields_vec_mut().push(preserves::value::IOValue::from(_tmp1.as_ref()));
                _tmp2.finish().wrap()
            },
            CompoundPattern::Tuple {patterns: _tmp0} => {
                let mut _tmp1 = preserves::value::Record(vec![(&*LIT_10_TUPLE).clone()]);
                _tmp1.fields_vec_mut().push(
                    {
                        let mut _tmp2 = vec![];
                        for _tmp3 in _tmp0 {_tmp2.push(preserves::value::IOValue::from(_tmp3));}
                        preserves::value::Value::Sequence(_tmp2).wrap()
                    }
                );
                _tmp1.finish().wrap()
            },
            CompoundPattern::TuplePrefix {fixed: _tmp0, variable: _tmp1} => {
                let mut _tmp2 = preserves::value::Record(vec![(&*LIT_11_TUPLE_PREFIX).clone()]);
                _tmp2.fields_vec_mut().push(
                    {
                        let mut _tmp3 = vec![];
                        for _tmp4 in _tmp0 {_tmp3.push(preserves::value::IOValue::from(_tmp4));}
                        preserves::value::Value::Sequence(_tmp3).wrap()
                    }
                );
                _tmp2.fields_vec_mut().push(preserves::value::IOValue::from(_tmp1.as_ref()));
                _tmp2.finish().wrap()
            },
            CompoundPattern::Dict {entries: _tmp0} => {
                let mut _tmp1 = preserves::value::Record(vec![(&*LIT_12_DICT).clone()]);
                _tmp1.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0.as_ref()));
                _tmp1.finish().wrap()
            },
        }
    }
}

fn _parse_definition_or(value: &preserves::value::IOValue) -> std::result::Result<Definition, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_13_OR { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = (&_tmp0.fields()[0]).value().to_sequence()?;
    if _tmp2.len() < 2 { return Err(_support::ParseError::ConformanceError); }
    let _tmp3 = NamedAlternative::try_from((&_tmp2[0]).clone())?;
    let _tmp4 = NamedAlternative::try_from((&_tmp2[1]).clone())?;
    let mut _tmp5 = std::vec::Vec::new();
    for _tmp6 in &_tmp2[2..] {let _tmp7 = NamedAlternative::try_from(_tmp6.clone())?; _tmp5.push(_tmp7);}
    Ok(Definition::Or {
        pattern_0: std::boxed::Box::new(_tmp3),
        pattern_1: std::boxed::Box::new(_tmp4),
        pattern_n: _tmp5
    })
}

fn _parse_definition_and(value: &preserves::value::IOValue) -> std::result::Result<Definition, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_14_AND { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = (&_tmp0.fields()[0]).value().to_sequence()?;
    if _tmp2.len() < 2 { return Err(_support::ParseError::ConformanceError); }
    let _tmp3 = NamedPattern::try_from((&_tmp2[0]).clone())?;
    let _tmp4 = NamedPattern::try_from((&_tmp2[1]).clone())?;
    let mut _tmp5 = std::vec::Vec::new();
    for _tmp6 in &_tmp2[2..] {let _tmp7 = NamedPattern::try_from(_tmp6.clone())?; _tmp5.push(_tmp7);}
    Ok(Definition::And {
        pattern_0: std::boxed::Box::new(_tmp3),
        pattern_1: std::boxed::Box::new(_tmp4),
        pattern_n: _tmp5
    })
}

fn _parse_definition_pattern(value: &preserves::value::IOValue) -> std::result::Result<Definition, _support::ParseError> {
    let _tmp0 = Pattern::try_from(value.clone())?;
    Ok(Definition::Pattern(std::boxed::Box::new(_tmp0)))
}

impl std::convert::TryFrom<preserves::value::IOValue> for Definition {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_definition_or(value) { return Ok(r); }
        if let Ok(r) = _parse_definition_and(value) { return Ok(r); }
        if let Ok(r) = _parse_definition_pattern(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&Definition> for preserves::value::IOValue {
    fn from(value: &Definition) -> Self {
        match value {
            Definition::Or {pattern_0: _tmp0, pattern_1: _tmp1, pattern_n: _tmp2} => {
                let mut _tmp3 = preserves::value::Record(vec![(&*LIT_13_OR).clone()]);
                _tmp3.fields_vec_mut().push(
                    {
                        let mut _tmp4 = vec![];
                        _tmp4.push(preserves::value::IOValue::from(_tmp0.as_ref()));
                        _tmp4.push(preserves::value::IOValue::from(_tmp1.as_ref()));
                        for _tmp5 in _tmp2 {_tmp4.push(preserves::value::IOValue::from(_tmp5));}
                        preserves::value::Value::Sequence(_tmp4).wrap()
                    }
                );
                _tmp3.finish().wrap()
            },
            Definition::And {pattern_0: _tmp0, pattern_1: _tmp1, pattern_n: _tmp2} => {
                let mut _tmp3 = preserves::value::Record(vec![(&*LIT_14_AND).clone()]);
                _tmp3.fields_vec_mut().push(
                    {
                        let mut _tmp4 = vec![];
                        _tmp4.push(preserves::value::IOValue::from(_tmp0.as_ref()));
                        _tmp4.push(preserves::value::IOValue::from(_tmp1.as_ref()));
                        for _tmp5 in _tmp2 {_tmp4.push(preserves::value::IOValue::from(_tmp5));}
                        preserves::value::Value::Sequence(_tmp4).wrap()
                    }
                );
                _tmp3.finish().wrap()
            },
            Definition::Pattern(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for Definitions {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let mut _tmp0 = preserves::value::Map::new();
        for (_tmp1, _tmp2) in value.value().to_dictionary()? {
            let _tmp3 = _tmp1.value().to_symbol()?;
            let _tmp4 = Definition::try_from(_tmp2.clone())?;
            _tmp0.insert(_tmp3.clone(), _tmp4);
        }
        Ok(Definitions(_tmp0))
    }
}

impl std::convert::From<&Definitions> for preserves::value::IOValue {
    fn from(value: &Definitions) -> Self {
        let Definitions(_tmp0) = value;
        preserves::value::Value::Dictionary(_tmp0.iter().map(|(_tmp1, _tmp2)| (
            preserves::value::Value::symbol(_tmp1).wrap(),
            preserves::value::IOValue::from(_tmp2)
        )).collect()).wrap()
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for DictionaryEntries {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let mut _tmp0 = preserves::value::Map::new();
        for (_tmp1, _tmp2) in value.value().to_dictionary()? {
            let _tmp3 = _Any::from_io_value(_tmp1)?;
            let _tmp4 = NamedSimplePattern::try_from(_tmp2.clone())?;
            _tmp0.insert(_tmp3.clone(), _tmp4);
        }
        Ok(DictionaryEntries(_tmp0))
    }
}

impl std::convert::From<&DictionaryEntries> for preserves::value::IOValue {
    fn from(value: &DictionaryEntries) -> Self {
        let DictionaryEntries(_tmp0) = value;
        preserves::value::Value::Dictionary(_tmp0.iter().map(|(_tmp1, _tmp2)| (_tmp1.to_io_value(), preserves::value::IOValue::from(_tmp2))).collect()).wrap()
    }
}

fn _parse_embedded_type_name_ref(value: &preserves::value::IOValue) -> std::result::Result<EmbeddedTypeName, _support::ParseError> {
    let _tmp0 = Ref::try_from(value.clone())?;
    Ok(EmbeddedTypeName::Ref(std::boxed::Box::new(_tmp0)))
}

fn _parse_embedded_type_name_false(value: &preserves::value::IOValue) -> std::result::Result<EmbeddedTypeName, _support::ParseError> {
    if value != &*LIT_15_FALSE { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(EmbeddedTypeName::False)
}

impl std::convert::TryFrom<preserves::value::IOValue> for EmbeddedTypeName {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_embedded_type_name_ref(value) { return Ok(r); }
        if let Ok(r) = _parse_embedded_type_name_false(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&EmbeddedTypeName> for preserves::value::IOValue {
    fn from(value: &EmbeddedTypeName) -> Self {
        match value {
            EmbeddedTypeName::Ref(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
            EmbeddedTypeName::False => (&*LIT_15_FALSE).clone(),
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for ModulePath {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let _tmp1 = value.value().to_sequence()?;
        let mut _tmp0 = std::vec::Vec::new();
        for _tmp2 in &_tmp1[0..] {let _tmp3 = _tmp2.value().to_symbol()?; _tmp0.push(_tmp3.clone());}
        Ok(ModulePath(_tmp0))
    }
}

impl std::convert::From<&ModulePath> for preserves::value::IOValue {
    fn from(value: &ModulePath) -> Self {
        let ModulePath(_tmp0) = value;
        {
            let mut _tmp1 = vec![];
            for _tmp2 in _tmp0 {_tmp1.push(preserves::value::Value::symbol(_tmp2).wrap());}
            preserves::value::Value::Sequence(_tmp1).wrap()
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for Modules {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let mut _tmp0 = preserves::value::Map::new();
        for (_tmp1, _tmp2) in value.value().to_dictionary()? {
            let _tmp3 = ModulePath::try_from(_tmp1.clone())?;
            let _tmp4 = Schema::try_from(_tmp2.clone())?;
            _tmp0.insert(_tmp3, _tmp4);
        }
        Ok(Modules(_tmp0))
    }
}

impl std::convert::From<&Modules> for preserves::value::IOValue {
    fn from(value: &Modules) -> Self {
        let Modules(_tmp0) = value;
        preserves::value::Value::Dictionary(_tmp0.iter().map(|(_tmp1, _tmp2)| (preserves::value::IOValue::from(_tmp1), preserves::value::IOValue::from(_tmp2))).collect()).wrap()
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for NamedAlternative {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let _tmp0 = value.value().to_sequence()?;
        if _tmp0.len() < 2 { return Err(_support::ParseError::ConformanceError); }
        let _tmp1 = (&_tmp0[0]).value().to_string()?;
        let _tmp2 = Pattern::try_from((&_tmp0[1]).clone())?;
        Ok(NamedAlternative {variant_label: _tmp1.clone(), pattern: _tmp2})
    }
}

impl std::convert::From<&NamedAlternative> for preserves::value::IOValue {
    fn from(value: &NamedAlternative) -> Self {
        let NamedAlternative {variant_label: _tmp0, pattern: _tmp1} = value;
        {
            let mut _tmp2 = vec![];
            _tmp2.push(preserves::value::Value::from(_tmp0).wrap());
            _tmp2.push(preserves::value::IOValue::from(_tmp1));
            preserves::value::Value::Sequence(_tmp2).wrap()
        }
    }
}

fn _parse_named_pattern_named(value: &preserves::value::IOValue) -> std::result::Result<NamedPattern, _support::ParseError> {
    let _tmp0 = Binding::try_from(value.clone())?;
    Ok(NamedPattern::Named(std::boxed::Box::new(_tmp0)))
}

fn _parse_named_pattern_anonymous(value: &preserves::value::IOValue) -> std::result::Result<NamedPattern, _support::ParseError> {
    let _tmp0 = Pattern::try_from(value.clone())?;
    Ok(NamedPattern::Anonymous(std::boxed::Box::new(_tmp0)))
}

impl std::convert::TryFrom<preserves::value::IOValue> for NamedPattern {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_named_pattern_named(value) { return Ok(r); }
        if let Ok(r) = _parse_named_pattern_anonymous(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&NamedPattern> for preserves::value::IOValue {
    fn from(value: &NamedPattern) -> Self {
        match value {
            NamedPattern::Named(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
            NamedPattern::Anonymous(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
        }
    }
}

fn _parse_named_simple_pattern_named(value: &preserves::value::IOValue) -> std::result::Result<NamedSimplePattern, _support::ParseError> {
    let _tmp0 = Binding::try_from(value.clone())?;
    Ok(NamedSimplePattern::Named(std::boxed::Box::new(_tmp0)))
}

fn _parse_named_simple_pattern_anonymous(value: &preserves::value::IOValue) -> std::result::Result<NamedSimplePattern, _support::ParseError> {
    let _tmp0 = SimplePattern::try_from(value.clone())?;
    Ok(NamedSimplePattern::Anonymous(std::boxed::Box::new(_tmp0)))
}

impl std::convert::TryFrom<preserves::value::IOValue> for NamedSimplePattern {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_named_simple_pattern_named(value) { return Ok(r); }
        if let Ok(r) = _parse_named_simple_pattern_anonymous(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&NamedSimplePattern> for preserves::value::IOValue {
    fn from(value: &NamedSimplePattern) -> Self {
        match value {
            NamedSimplePattern::Named(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
            NamedSimplePattern::Anonymous(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
        }
    }
}

fn _parse_pattern_simple_pattern(value: &preserves::value::IOValue) -> std::result::Result<Pattern, _support::ParseError> {
    let _tmp0 = SimplePattern::try_from(value.clone())?;
    Ok(Pattern::SimplePattern(std::boxed::Box::new(_tmp0)))
}

fn _parse_pattern_compound_pattern(value: &preserves::value::IOValue) -> std::result::Result<Pattern, _support::ParseError> {
    let _tmp0 = CompoundPattern::try_from(value.clone())?;
    Ok(Pattern::CompoundPattern(std::boxed::Box::new(_tmp0)))
}

impl std::convert::TryFrom<preserves::value::IOValue> for Pattern {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_pattern_simple_pattern(value) { return Ok(r); }
        if let Ok(r) = _parse_pattern_compound_pattern(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&Pattern> for preserves::value::IOValue {
    fn from(value: &Pattern) -> Self {
        match value {
            Pattern::SimplePattern(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
            Pattern::CompoundPattern(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for Ref {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let _tmp0 = value.value().to_record(None)?;
        if _tmp0.label() != &*LIT_16_REF { return Err(_support::ParseError::ConformanceError); }
        let _tmp1 = ();
        if _tmp0.fields().len() < 2 { return Err(_support::ParseError::ConformanceError); }
        let _tmp2 = ModulePath::try_from((&_tmp0.fields()[0]).clone())?;
        let _tmp3 = (&_tmp0.fields()[1]).value().to_symbol()?;
        Ok(Ref {module: _tmp2, name: _tmp3.clone()})
    }
}

impl std::convert::From<&Ref> for preserves::value::IOValue {
    fn from(value: &Ref) -> Self {
        let Ref {module: _tmp0, name: _tmp1} = value;
        {
            let mut _tmp2 = preserves::value::Record(vec![(&*LIT_16_REF).clone()]);
            _tmp2.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0));
            _tmp2.fields_vec_mut().push(preserves::value::Value::symbol(_tmp1).wrap());
            _tmp2.finish().wrap()
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for Schema {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        let _tmp0 = value.value().to_record(None)?;
        if _tmp0.label() != &*LIT_17_SCHEMA { return Err(_support::ParseError::ConformanceError); }
        let _tmp1 = ();
        if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
        let _tmp2 = (&_tmp0.fields()[0]).value().to_dictionary()?;
        let _tmp3 = _tmp2.get(&*LIT_18_DEFINITIONS).ok_or(_support::ParseError::ConformanceError)?;
        let _tmp4 = Definitions::try_from(_tmp3.clone())?;
        let _tmp5 = _tmp2.get(&*LIT_19_EMBEDDED_TYPE).ok_or(_support::ParseError::ConformanceError)?;
        let _tmp6 = EmbeddedTypeName::try_from(_tmp5.clone())?;
        let _tmp7 = _tmp2.get(&*LIT_20_VERSION).ok_or(_support::ParseError::ConformanceError)?;
        let _tmp8 = Version::try_from(_tmp7.clone())?;
        Ok(Schema {definitions: _tmp4, embedded_type: _tmp6, version: _tmp8})
    }
}

impl std::convert::From<&Schema> for preserves::value::IOValue {
    fn from(value: &Schema) -> Self {
        let Schema {definitions: _tmp0, embedded_type: _tmp1, version: _tmp2} = value;
        {
            let mut _tmp3 = preserves::value::Record(vec![(&*LIT_17_SCHEMA).clone()]);
            _tmp3.fields_vec_mut().push(
                {
                    let mut _tmp4 = preserves::value::Map::new();
                    _tmp4.insert((&*LIT_18_DEFINITIONS).clone(), preserves::value::IOValue::from(_tmp0));
                    _tmp4.insert((&*LIT_19_EMBEDDED_TYPE).clone(), preserves::value::IOValue::from(_tmp1));
                    _tmp4.insert((&*LIT_20_VERSION).clone(), preserves::value::IOValue::from(_tmp2));
                    preserves::value::Value::Dictionary(_tmp4).wrap()
                }
            );
            _tmp3.finish().wrap()
        }
    }
}

fn _parse_simple_pattern_any(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    if value != &*LIT_21_ANY { return Err(_support::ParseError::ConformanceError); }
    let _tmp0 = ();
    Ok(SimplePattern::Any)
}

fn _parse_simple_pattern_atom(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_22_ATOM { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = AtomKind::try_from((&_tmp0.fields()[0]).clone())?;
    Ok(SimplePattern::Atom {atom_kind: std::boxed::Box::new(_tmp2)})
}

fn _parse_simple_pattern_embedded(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_23_EMBEDDED { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = SimplePattern::try_from((&_tmp0.fields()[0]).clone())?;
    Ok(SimplePattern::Embedded {interface: std::boxed::Box::new(_tmp2)})
}

fn _parse_simple_pattern_lit(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_24_LIT { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = _Any::from_io_value((&_tmp0.fields()[0]))?;
    Ok(SimplePattern::Lit {value: _tmp2.clone()})
}

fn _parse_simple_pattern_seqof(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_25_SEQOF { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = SimplePattern::try_from((&_tmp0.fields()[0]).clone())?;
    Ok(SimplePattern::Seqof {pattern: std::boxed::Box::new(_tmp2)})
}

fn _parse_simple_pattern_setof(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_26_SETOF { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 1 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = SimplePattern::try_from((&_tmp0.fields()[0]).clone())?;
    Ok(SimplePattern::Setof {pattern: std::boxed::Box::new(_tmp2)})
}

fn _parse_simple_pattern_dictof(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    let _tmp0 = value.value().to_record(None)?;
    if _tmp0.label() != &*LIT_27_DICTOF { return Err(_support::ParseError::ConformanceError); }
    let _tmp1 = ();
    if _tmp0.fields().len() < 2 { return Err(_support::ParseError::ConformanceError); }
    let _tmp2 = SimplePattern::try_from((&_tmp0.fields()[0]).clone())?;
    let _tmp3 = SimplePattern::try_from((&_tmp0.fields()[1]).clone())?;
    Ok(SimplePattern::Dictof {key: std::boxed::Box::new(_tmp2), value: std::boxed::Box::new(_tmp3)})
}

fn _parse_simple_pattern_ref(value: &preserves::value::IOValue) -> std::result::Result<SimplePattern, _support::ParseError> {
    let _tmp0 = Ref::try_from(value.clone())?;
    Ok(SimplePattern::Ref(std::boxed::Box::new(_tmp0)))
}

impl std::convert::TryFrom<preserves::value::IOValue> for SimplePattern {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if let Ok(r) = _parse_simple_pattern_any(value) { return Ok(r); }
        if let Ok(r) = _parse_simple_pattern_atom(value) { return Ok(r); }
        if let Ok(r) = _parse_simple_pattern_embedded(value) { return Ok(r); }
        if let Ok(r) = _parse_simple_pattern_lit(value) { return Ok(r); }
        if let Ok(r) = _parse_simple_pattern_seqof(value) { return Ok(r); }
        if let Ok(r) = _parse_simple_pattern_setof(value) { return Ok(r); }
        if let Ok(r) = _parse_simple_pattern_dictof(value) { return Ok(r); }
        if let Ok(r) = _parse_simple_pattern_ref(value) { return Ok(r); }
        Err(_support::ParseError::ConformanceError)
    }
}

impl std::convert::From<&SimplePattern> for preserves::value::IOValue {
    fn from(value: &SimplePattern) -> Self {
        match value {
            SimplePattern::Any => (&*LIT_21_ANY).clone(),
            SimplePattern::Atom {atom_kind: _tmp0} => {
                let mut _tmp1 = preserves::value::Record(vec![(&*LIT_22_ATOM).clone()]);
                _tmp1.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0.as_ref()));
                _tmp1.finish().wrap()
            },
            SimplePattern::Embedded {interface: _tmp0} => {
                let mut _tmp1 = preserves::value::Record(vec![(&*LIT_23_EMBEDDED).clone()]);
                _tmp1.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0.as_ref()));
                _tmp1.finish().wrap()
            },
            SimplePattern::Lit {value: _tmp0} => {
                let mut _tmp1 = preserves::value::Record(vec![(&*LIT_24_LIT).clone()]);
                _tmp1.fields_vec_mut().push(_tmp0.to_io_value());
                _tmp1.finish().wrap()
            },
            SimplePattern::Seqof {pattern: _tmp0} => {
                let mut _tmp1 = preserves::value::Record(vec![(&*LIT_25_SEQOF).clone()]);
                _tmp1.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0.as_ref()));
                _tmp1.finish().wrap()
            },
            SimplePattern::Setof {pattern: _tmp0} => {
                let mut _tmp1 = preserves::value::Record(vec![(&*LIT_26_SETOF).clone()]);
                _tmp1.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0.as_ref()));
                _tmp1.finish().wrap()
            },
            SimplePattern::Dictof {key: _tmp0, value: _tmp1} => {
                let mut _tmp2 = preserves::value::Record(vec![(&*LIT_27_DICTOF).clone()]);
                _tmp2.fields_vec_mut().push(preserves::value::IOValue::from(_tmp0.as_ref()));
                _tmp2.fields_vec_mut().push(preserves::value::IOValue::from(_tmp1.as_ref()));
                _tmp2.finish().wrap()
            },
            SimplePattern::Ref(_tmp0) => preserves::value::IOValue::from(_tmp0.as_ref()),
        }
    }
}

impl std::convert::TryFrom<preserves::value::IOValue> for Version {
    type Error = _support::ParseError;
    fn try_from(value: preserves::value::IOValue) -> std::result::Result<Self, Self::Error> {
        let value = &value;
        if value != &*LIT_28_1 { return Err(_support::ParseError::ConformanceError); }
        let _tmp0 = ();
        Ok(Version)
    }
}

impl std::convert::From<&Version> for preserves::value::IOValue {fn from(value: &Version) -> Self {let Version = value; (&*LIT_28_1).clone()}}

